package ejbs;


import javax.annotation.Resource;
import javax.ejb.EJBException;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;
import javax.ejb.Timeout;
import javax.ejb.Timer;
import javax.ejb.TimerConfig;
import javax.ejb.TimerService;

import com.dwl.base.logging.DWLLoggerManager;
import com.dwl.base.logging.IDWLLogger;
import com.ibm.im.rdm.notifications.SerializableExtensionParameters;

@Stateless
public class MyTimer {

	private static final long serialVersionUID = 2594300466733372516L;
	
	private static final IDWLLogger logger = DWLLoggerManager.getLogger(MyTimer.class);

	@Resource(name="sessionContext")
	private SessionContext sessionContext;

	// This method is called by the container when the timer expires.
	@Timeout
	public void timeout(Timer theTimer) {
		//You can place code that is typically placed in an EJB method.
		String whyWasICalled = (String) theTimer.getInfo();
		logger.finest("## Timeout was called");
		logger.finest("## ActionType in bean: "+_sep.getActionType());
	} 
	
	SerializableExtensionParameters _sep;

	//This business method causes the timeout() method to begin in 1 second.
	public void fireTimer(SerializableExtensionParameters sep) throws EJBException  {
		TimerService theTimerService = sessionContext.getTimerService();
		TimerConfig theTimerConfig = null;
		_sep = sep;
		theTimerService.createSingleActionTimer(1000, theTimerConfig);
	} 

} 

